package cn.iocoder.yudao.module.pms.dal.mysql.iotmaterialgroup;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.pms.controller.admin.iotmaterialgroup.vo.IotMaterialGroupListReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotmaterialgroup.vo.IotMaterialGroupPageReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.IotProductClassifyDO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotmaterialgroup.IotMaterialGroupDO;
import org.apache.ibatis.annotations.Mapper;

import java.util.Collection;
import java.util.List;

/**
 * PMS 功能优化 物料组 Mapper
 *
 * @author 芋道源码
 */
@Mapper
public interface IotMaterialGroupMapper extends BaseMapperX<IotMaterialGroupDO> {

    default PageResult<IotMaterialGroupDO> selectPage(IotMaterialGroupPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<IotMaterialGroupDO>()
                .likeIfPresent(IotMaterialGroupDO::getName, reqVO.getName())
                .eqIfPresent(IotMaterialGroupDO::getParentId, reqVO.getParentId())
                .eqIfPresent(IotMaterialGroupDO::getSort, reqVO.getSort())
                .eqIfPresent(IotMaterialGroupDO::getStatus, reqVO.getStatus())
                .eqIfPresent(IotMaterialGroupDO::getRemark, reqVO.getRemark())
                .betweenIfPresent(IotMaterialGroupDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(IotMaterialGroupDO::getId));
    }

    default List<IotMaterialGroupDO> selectList(IotMaterialGroupListReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<IotMaterialGroupDO>()
                .likeIfPresent(IotMaterialGroupDO::getName, reqVO.getName())
                .eqIfPresent(IotMaterialGroupDO::getStatus, reqVO.getStatus()));
    }

    default List<IotMaterialGroupDO> selectListByParentId(Collection<Long> parentIds) {
        return selectList(IotMaterialGroupDO::getParentId, parentIds);
    }

}